#include <DxLib.h>
#include "Vector.h"
typedef Linear::Vector<double> Vec;

const double dt = 1.0/60.0;


struct AABB
{
	AABB( Vec s, Vec l)
		:s_(s),l_(l / 2.0)
	{
	}

	void Draw() const
	{
		DxLib::DrawBox( int( s_.x - l_.x ), int( s_.y - l_.y ), int( s_.x + l_.x ), int( s_.y + l_.y ), 0x00ff00, 0);
	}

	Vec s_;		//S
	Vec l_;		//eӂ̒̔
};

//AABBƈʒuŋߖT_߂
Vec GetClosestPointAABB( AABB aabb, Vec p )
{
	for( int i = 1; i <= 2; ++i )
	{
		if( p[i] < aabb.s_[i] - aabb.l_[i] )
			p[i] =  aabb.s_[i] - aabb.l_[i];
		if( p[i] > aabb.s_[i] + aabb.l_[i] )
			p[i] =  aabb.s_[i] + aabb.l_[i];
	}
	return p;
}


struct Circle
{
	Circle( Vec s, double r )
		:s_(s),r_(r)
	{
	}

	void Update()
	{
		char key[256];
		GetHitKeyStateAll( key );
		if( key[ KEY_INPUT_RIGHT  ] )
		{
			s_.x += 60.0*dt;
		}
		if( key[ KEY_INPUT_LEFT  ] )
		{
			s_.x -= 60.0*dt;
		}
		if( key[ KEY_INPUT_UP  ] )
		{
			s_.y -= 60.0*dt;
		}
		if( key[ KEY_INPUT_DOWN  ] )
		{
			s_.y += 60.0*dt;
		}
	}

	//Փ˔ƕ␳
	void Detection( const AABB& aabb )
	{
		Vec cp = GetClosestPointAABB( aabb, s_ );

		//Փ˂Ăꍇ
		double r2 = Linear::VDistanceSq( cp, s_ ); //̊֐2_Ԃ̋2Ԃ
		if( r2 < r_*r_ )
		{
			//xNg߂Ĉʒu␳
			Vec orientation = cp - s_;
			orientation.Normalize();			//xNg̐K
			orientation *= -( r_ - sqrt( r2 ) );
			s_ += orientation;
		}
	}
	void Draw() const
	{
		DxLib::DrawCircle( int( s_.x ), int( s_.y ),r_, 0xFF0000 );
	}

public:

	Vec s_;		//ʒu
	double r_;	//a

};

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow ){
	if( ChangeWindowMode(TRUE) != DX_CHANGESCREEN_OK || DxLib_Init() == -1 ) return -1; //
	SetDrawScreen( DX_SCREEN_BACK );        //ʂɐݒ
	AABB aabb1( Vec( 100.0, 300.0, 0.0 ), Vec ( 200.0, 200.0, 0.0 ) );
	AABB aabb2( Vec( 400.0, 300.0, 0.0 ), Vec ( 200.0, 200.0, 0.0 ) );
	Circle c( Vec( 250.0,300.0, 0.0 ), 20 );
	while(!ProcessMessage() && !ClearDrawScreen()){
		c.Update();
		c.Detection( aabb1 );
		c.Detection( aabb2 );

		aabb1.Draw();
		aabb2.Draw();
		c.Draw();

		clsDx();
		ScreenFlip();//ʂ\ʂɔf

	}
	DxLib_End();
	return 0;
}
